#ifndef __COMMON_DEF_H__
#define __COMMON_DEF_H__

#include <stdint.h>
#include <stddef.h>
#include "plc_abi.h"
#include "iec/iec_std_lib.h"

#define MEM_BYTE_SIZE           __ALIGN64(5120)
#define INPUT_BYTE_SIZE         __ALIGN64(32)
#define OUTPUT_BYTE_SIZE        __ALIGN64(16)

#define USE_TRACE           1

#if USE_TRACE
#define TRACE_VAR_MAX_NUM               16
#define TRACE_POINT_MAX_BYTES           64
#endif

// The following 10 rows will be updated by FSU backend after STCompiler.exe finished.
#define __PORT_1_INDEX 255
#define __PORT_2_INDEX 255
#define __PORT_3_INDEX 255
#define __PORT_4_INDEX 255
#define __PORT_10_INDEX 255
#define __PORT_1_PERI_NAME NULL
#define __PORT_2_PERI_NAME "Serial:Local_1"
#define __PORT_3_PERI_NAME NULL
#define __PORT_4_PERI_NAME NULL
#define __PORT_10_PERI_NAME NULL

#define MC_GROUP_MAX_AXIS_NUM 4

extern int plc_create_task(const char* task_name, uint32_t priority, uint64_t interval_us, PlcTaskFuncInit task_init, PlcTaskFuncRun task_run, PlcTaskFuncTrigger task_trigger);
extern void* plc_find_sys_api(const char* api_id, void** api_context);
extern void* plc_find_sys_var(const char* var_id, uint8_t* bit_mask);
extern void plc_update_start(void);
extern void plc_update_end(void);

#endif
