#include "common_def.h"
#include "mem_def.h"
#include "sys_lib_motion.h"
#include "sys_lib_extension_type.h"
#include "cam.inc"

// Globale memory
MemM __mem = {0};
MemI __mem_input = {0};
MemQ __mem_output = {0};

// Globale variables
__DECLARE_RESOURCE(default_resource,
    __DECLARE_VAR_LOCATED(INT,A1);
    __DECLARE_VAR_LOCATED(INT,A2);
    __DECLARE_VAR_LOCATED(INT,A3);
    __DECLARE_VAR_LOCATED(INT,A4);
    __DECLARE_VAR_LOCATED(INT,A5);
    __DECLARE_VAR_LOCATED(INT,A6);
    __DECLARE_VAR_LOCATED(INT,A7);
    __DECLARE_VAR_LOCATED(INT,A8);
    __DECLARE_VAR_LOCATED(INT,A9);
    __DECLARE_VAR_LOCATED(INT,A10);
    __DECLARE_VAR_LOCATED(BOOL,B1);
    __DECLARE_VAR_LOCATED(BOOL,B2);
    __DECLARE_VAR_LOCATED(BOOL,B3);
    __DECLARE_VAR_LOCATED(BOOL,B4);
    __DECLARE_VAR_LOCATED(BOOL,B5);
    __DECLARE_VAR_LOCATED(BOOL,B6);
    __DECLARE_VAR_LOCATED(BOOL,B7);
    __DECLARE_VAR_LOCATED(BOOL,B8);
    __DECLARE_VAR_LOCATED(BOOL,B9);
    __DECLARE_VAR_LOCATED(BOOL,B10);
);

// POUs
#include "pous.inc"

// TASKs
// -- Mast --
Main Mast_Main_1={0};
PlcAppRet task_Mast_init(void)
{
    PlcAppRet ret = (PlcAppRet){kPlcApp_Success,NULL};
    ret = main_init__(&Mast_Main_1);
    if(ret.code!=kPlcApp_Success)
        return ret;
    __INIT_EXTERNAL_LOCATED(Mast_Main_1.,B1,default_resource);
    __INIT_EXTERNAL_LOCATED(Mast_Main_1.,B7,default_resource);
    return ret;
}

int task_Mast_run(void)
{
    main_body__(&Mast_Main_1);
    return 0;
}

int task_Mast_trigger(void)
{
    return 0;
}

// RESOURCE
PlcAppRet resource_default_init__(void)
{
    const char* name = NULL;

    name = sys_lib_load_misc();
    if(name!=NULL)
        return (PlcAppRet){kPlcApp_SysLibApiNotFound,name};
    name = sys_lib_load_modbus();
    if(name!=NULL)
        return (PlcAppRet){kPlcApp_SysLibApiNotFound,name};

    memset(&resource_default_resource,0,sizeof(resource_default_resource));

    if(plc_create_task("Mast", 15, 5 * 1000, task_Mast_init, task_Mast_run, task_Mast_trigger)!=0)
        return (PlcAppRet){kPlcApp_CreateTaskFailed,"Mast"};

    return (PlcAppRet){kPlcApp_Success,NULL};
}

#include "plc_vars.inc"

// CONFIGURATION
PlcAppRet configuration_default_init(void)
{
    return resource_default_init__();
}

