#ifndef __MEM_DEF_H__
#define __MEM_DEF_H__

#include "common_def.h"
#include "user_def.h"
#include "sys_lib/sys_lib_extension_type.h"

// The following 3 rows will be replaced by STCompiler.exe.
IEC_MEM_BLOCK_DEF(MemM, MEM_BYTE_SIZE, 
    // X
    struct
    {
        uint8_t rev1 [4096];
        struct
        {
            uint8_t B1 : 1;    // %MX4096.0, size:{1 byte, 1 X}
            uint8_t B2 : 1;    // %MX4096.1, size:{1 byte, 1 X}
            uint8_t B3 : 1;    // %MX4096.2, size:{1 byte, 1 X}
            uint8_t B4 : 1;    // %MX4096.3, size:{1 byte, 1 X}
            uint8_t B5 : 1;    // %MX4096.4, size:{1 byte, 1 X}
            uint8_t B6 : 1;    // %MX4096.5, size:{1 byte, 1 X}
            uint8_t B7 : 1;    // %MX4096.6, size:{1 byte, 1 X}
            uint8_t B8 : 1;    // %MX4096.7, size:{1 byte, 1 X}
        };
        struct
        {
            uint8_t B9 : 1;    // %MX4097.0, size:{1 byte, 1 X}
            uint8_t B10 : 1;    // %MX4097.1, size:{1 byte, 1 X}
        };
    };

    // W
    struct
    {
        uint16_t rev2 [2052];
        INT A1;    // %MW2052, size:{16 byte, 1 W}
        INT A2;    // %MW2053, size:{16 byte, 1 W}
        INT A3;    // %MW2054, size:{16 byte, 1 W}
        INT A4;    // %MW2055, size:{16 byte, 1 W}
        INT A5;    // %MW2056, size:{16 byte, 1 W}
        INT A6;    // %MW2057, size:{16 byte, 1 W}
        INT A7;    // %MW2058, size:{16 byte, 1 W}
        INT A8;    // %MW2059, size:{16 byte, 1 W}
        INT A9;    // %MW2060, size:{16 byte, 1 W}
        INT A10;    // %MW2061, size:{16 byte, 1 W}
    };
);
IEC_MEM_BLOCK_DEF(MemI, INPUT_BYTE_SIZE, struct { };);
IEC_MEM_BLOCK_DEF(MemQ, OUTPUT_BYTE_SIZE, struct { };);

extern MemM __mem;
extern MemI __mem_input;
extern MemQ __mem_output;

#endif
